Skip to main content

Create a materialized table

POST 

/sql/v1/organizations/:organization_id/environments/:environment_id/databases/:kafka_cluster_id/materialized-tables

General Availability

Create a new Materialized Table.

Request

Responses

Materialized Table is being created

Response Headers
    X-Request-Id

    The unique identifier for the API request.

    Location

    Materialized Table uri

OpenAPI definition (YAML)
paths:
  /sql/v1/organizations/{organization_id}/environments/{environment_id}/databases/{kafka_cluster_id}/materialized-tables:
    post:
      x-lifecycle-stage: General Availability
      operationId: createSqlv1MaterializedTable
      description: '[![General Availability](https://img.shields.io/badge/Lifecycle%20Stage-General%20Availability-%2345c6e8)](#section/Versioning/API-Lifecycle-Policy)


        Create a new Materialized Table.

        '
      parameters:
      - in: path
        name: organization_id
        required: true
        schema:
          type: string
          format: uuid
        description: The unique identifier for the organization
      - in: path
        name: environment_id
        required: true
        schema:
          type: string
        description: The unique identifier for the environment.
      - in: path
        name: kafka_cluster_id
        required: true
        schema:
          type: string
        description: The unique identifier for the database.
      tags:
      - Materialized Tables (sql/v1)
      security:
      - resource-api-key: []
      - global-api-key: []
      - external-access-token: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              allOf:
              - type: object
                description: Represents a Materialized Table resource.
                required:
                - metadata
                - name
                - spec
                properties:
                  metadata:
                    allOf:
                    - description: ObjectMeta is metadata that all persisted resources must have, which
                        includes all objects users must create.
                      properties: {}
                      readOnly: true
                      title: ObjectMeta
                    - type: object
                      properties:
                        self:
                          example: https://flink.us-west1.aws.confluent.cloud/sql/v1/environments/env-123/databases/lkc-123/materialized-tables/high-value-orders
                        uid:
                          example: 12345678-1234-1234-1234-123456789012
                        resource_version:
                          example: a23av
                        resource_name:
                          example: ''
                        labels:
                          type: object
                          additionalProperties:
                            type: string
                  name:
                    type: string
                    description: The user-provided name of the resource, unique within the Kafka cluster.
                      May contain ASCII alphanumerics, '.', '_' and '-'; must not be '.' or '..'; max
                      length 249.
                    pattern: ^[a-zA-Z0-9._-]+$
                    maxLength: 249
                    example: high-value-orders
                  spec:
                    type: object
                    description: The specifications of the Materialized Table.
                    properties:
                      kafka_cluster_id:
                        type: string
                        description: 'The ID of the Kafka cluster hosting the Materialized Table''s topic.

                          This value must match the `kafka_cluster_id` path parameter.

                          It is immutable after creation and is ignored or rejected on update if changed.'
                        example: lkc-12345
                      compute_pool_id:
                        type: string
                        description: 'The id associated with the compute pool in context.

                          If not specified, the materialized table will use the default compute pool.
                          The default pool is automatically determined by the system.'
                        example: lfcp-123
                      principal:
                        type: string
                        description: The id of a principal this Materialized Table query runs as.
                        example: sa-abc123
                        maxLength: 255
                      stopped:
                        type: boolean
                        description: Indicates whether the Materialized Table query should be stopped.
                        example: false
                      table_options:
                        type: object
                        description: Defines configuration properties for the table, equivalent to the
                          SQL 'WITH' clause
                        additionalProperties:
                          type: string
                        maxProperties: 8192
                      session_options:
                        type: object
                        description: Session configurations equivalent to the SQL 'SET' statement. Only
                          applicable on creation; ignored on update.
                        additionalProperties:
                          type: string
                        maxProperties: 8192
                      columns:
                        type: array
                        description: Details of each column in Materialized Table resource. If columns
                          are not specified, we infer from query. If it's specified it must be compatible
                          with the types in the query.
                        items:
                          type: object
                          description: Details of a column in the Materialized Table.
                          discriminator:
                            propertyName: kind
                            mapping:
                              Physical:
                                description: Physical columns define the structure of the table and the
                                  data types of its fields.
                                allOf:
                                - type: object
                                  required:
                                  - name
                                  - type
                                  properties:
                                    name:
                                      type: string
                                      description: The name of the column.
                                    type:
                                      type: object
                                      properties:
                                        type:
                                          type: string
                                          description: The data type of the column.
                                        nullable:
                                          type: boolean
                                          description: Indicates whether values in this column can be
                                            null.
                                        length:
                                          type: integer
                                          format: int32
                                          description: The length of the data type.
                                        precision:
                                          type: integer
                                          format: int32
                                          description: The precision of the data type.
                                        scale:
                                          type: integer
                                          format: int32
                                          description: The scale of the data type.
                                        key_type:
                                          allOf:
                                          - circular(DataType)
                                          description: The type of the key in the data type (if applicable).
                                        value_type:
                                          allOf:
                                          - circular(DataType)
                                          description: The type of the value in the data type (if applicable).
                                        element_type:
                                          allOf:
                                          - circular(DataType)
                                          description: The type of the element in the data type (if applicable).
                                        fields:
                                          type: array
                                          items:
                                            type: object
                                            properties:
                                              name:
                                                type: string
                                                description: The name of the field.
                                              field_type:
                                                allOf:
                                                - circular(DataType)
                                                description: The data type of the field.
                                              description:
                                                type: string
                                                description: The description of the field.
                                            required:
                                            - name
                                            - field_type
                                            title: RowFieldType
                                          description: The fields of the element in the data type (if
                                            applicable).
                                        resolution:
                                          type: string
                                          description: The resolution of the data type (if applicable).
                                        fractional_precision:
                                          type: integer
                                          format: int32
                                          description: The fractional precision of the data type (if applicable).
                                        class_name:
                                          type: string
                                          description: The class name of the structured data type (if
                                            applicable).
                                      required:
                                      - type
                                      - nullable
                                      title: DataType
                                    comment:
                                      type: string
                                      description: A comment or description for the column.
                                  title: sql.v1.ColumnCommon
                                - type: object
                                  required:
                                  - kind
                                  properties:
                                    name:
                                      example: user_id
                                    type:
                                      example:
                                        type: BIGINT
                                        nullable: false
                                    kind:
                                      type: string
                                      description: The kind of column.
                                      enum:
                                      - Physical
                                      example: Physical
                                title: sql.v1.PhysicalColumn
                              Metadata:
                                description: Metadata columns reference system properties.
                                allOf:
                                - type: object
                                  required:
                                  - name
                                  - type
                                  properties:
                                    name:
                                      type: string
                                      description: The name of the column.
                                    type:
                                      type: object
                                      properties:
                                        type:
                                          type: string
                                          description: The data type of the column.
                                        nullable:
                                          type: boolean
                                          description: Indicates whether values in this column can be
                                            null.
                                        length:
                                          type: integer
                                          format: int32
                                          description: The length of the data type.
                                        precision:
                                          type: integer
                                          format: int32
                                          description: The precision of the data type.
                                        scale:
                                          type: integer
                                          format: int32
                                          description: The scale of the data type.
                                        key_type:
                                          allOf:
                                          - circular(DataType)
                                          description: The type of the key in the data type (if applicable).
                                        value_type:
                                          allOf:
                                          - circular(DataType)
                                          description: The type of the value in the data type (if applicable).
                                        element_type:
                                          allOf:
                                          - circular(DataType)
                                          description: The type of the element in the data type (if applicable).
                                        fields:
                                          type: array
                                          items:
                                            type: object
                                            properties:
                                              name:
                                                type: string
                                                description: The name of the field.
                                              field_type:
                                                allOf:
                                                - circular(DataType)
                                                description: The data type of the field.
                                              description:
                                                type: string
                                                description: The description of the field.
                                            required:
                                            - name
                                            - field_type
                                            title: RowFieldType
                                          description: The fields of the element in the data type (if
                                            applicable).
                                        resolution:
                                          type: string
                                          description: The resolution of the data type (if applicable).
                                        fractional_precision:
                                          type: integer
                                          format: int32
                                          description: The fractional precision of the data type (if applicable).
                                        class_name:
                                          type: string
                                          description: The class name of the structured data type (if
                                            applicable).
                                      required:
                                      - type
                                      - nullable
                                      title: DataType
                                    comment:
                                      type: string
                                      description: A comment or description for the column.
                                  title: sql.v1.ColumnCommon
                                - type: object
                                  required:
                                  - kind
                                  - metadata_key
                                  properties:
                                    name:
                                      example: table_offset
                                    type:
                                      example:
                                        type: BIGINT
                                        nullable: false
                                    kind:
                                      type: string
                                      description: The kind of column.
                                      enum:
                                      - Metadata
                                      example: Metadata
                                    metadata_key:
                                      type: string
                                      description: The system metadata key to reference.
                                      example: offset
                                    virtual:
                                      type: boolean
                                      description: Indicates if the metadata column is virtual.
                                      default: false
                                      example: true
                                title: sql.v1.MetadataColumn
                              Computed:
                                description: Computed columns are generated via an expression.
                                allOf:
                                - type: object
                                  required:
                                  - name
                                  - type
                                  properties:
                                    name:
                                      type: string
                                      description: The name of the column.
                                    type:
                                      type: object
                                      properties:
                                        type:
                                          type: string
                                          description: The data type of the column.
                                        nullable:
                                          type: boolean
                                          description: Indicates whether values in this column can be
                                            null.
                                        length:
                                          type: integer
                                          format: int32
                                          description: The length of the data type.
                                        precision:
                                          type: integer
                                          format: int32
                                          description: The precision of the data type.
                                        scale:
                                          type: integer
                                          format: int32
                                          description: The scale of the data type.
                                        key_type:
                                          allOf:
                                          - circular(DataType)
                                          description: The type of the key in the data type (if applicable).
                                        value_type:
                                          allOf:
                                          - circular(DataType)
                                          description: The type of the value in the data type (if applicable).
                                        element_type:
                                          allOf:
                                          - circular(DataType)
                                          description: The type of the element in the data type (if applicable).
                                        fields:
                                          type: array
                                          items:
                                            type: object
                                            properties:
                                              name:
                                                type: string
                                                description: The name of the field.
                                              field_type:
                                                allOf:
                                                - circular(DataType)
                                                description: The data type of the field.
                                              description:
                                                type: string
                                                description: The description of the field.
                                            required:
                                            - name
                                            - field_type
                                            title: RowFieldType
                                          description: The fields of the element in the data type (if
                                            applicable).
                                        resolution:
                                          type: string
                                          description: The resolution of the data type (if applicable).
                                        fractional_precision:
                                          type: integer
                                          format: int32
                                          description: The fractional precision of the data type (if applicable).
                                        class_name:
                                          type: string
                                          description: The class name of the structured data type (if
                                            applicable).
                                      required:
                                      - type
                                      - nullable
                                      title: DataType
                                    comment:
                                      type: string
                                      description: A comment or description for the column.
                                  title: sql.v1.ColumnCommon
                                - type: object
                                  required:
                                  - kind
                                  - expression
                                  properties:
                                    name:
                                      example: total_price
                                    type:
                                      example:
                                        type: DECIMAL
                                        nullable: false
                                        precision: 10
                                        scale: 2
                                    kind:
                                      type: string
                                      description: The kind of column.
                                      enum:
                                      - Computed
                                      example: Computed
                                    expression:
                                      type: string
                                      description: The SQL expression used to compute the column value.
                                      example: quantity * price
                                    virtual:
                                      type: boolean
                                      description: Indicates if the computed column is virtual.
                                      default: false
                                      example: true
                                title: sql.v1.ComputedColumn
                          oneOf:
                          - description: Physical columns define the structure of the table and the data
                              types of its fields.
                            allOf:
                            - type: object
                              required:
                              - name
                              - type
                              properties:
                                name:
                                  type: string
                                  description: The name of the column.
                                type:
                                  type: object
                                  properties:
                                    type:
                                      type: string
                                      description: The data type of the column.
                                    nullable:
                                      type: boolean
                                      description: Indicates whether values in this column can be null.
                                    length:
                                      type: integer
                                      format: int32
                                      description: The length of the data type.
                                    precision:
                                      type: integer
                                      format: int32
                                      description: The precision of the data type.
                                    scale:
                                      type: integer
                                      format: int32
                                      description: The scale of the data type.
                                    key_type:
                                      allOf:
                                      - circular(DataType)
                                      description: The type of the key in the data type (if applicable).
                                    value_type:
                                      allOf:
                                      - circular(DataType)
                                      description: The type of the value in the data type (if applicable).
                                    element_type:
                                      allOf:
                                      - circular(DataType)
                                      description: The type of the element in the data type (if applicable).
                                    fields:
                                      type: array
                                      items:
                                        type: object
                                        properties:
                                          name:
                                            type: string
                                            description: The name of the field.
                                          field_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The data type of the field.
                                          description:
                                            type: string
                                            description: The description of the field.
                                        required:
                                        - name
                                        - field_type
                                        title: RowFieldType
                                      description: The fields of the element in the data type (if applicable).
                                    resolution:
                                      type: string
                                      description: The resolution of the data type (if applicable).
                                    fractional_precision:
                                      type: integer
                                      format: int32
                                      description: The fractional precision of the data type (if applicable).
                                    class_name:
                                      type: string
                                      description: The class name of the structured data type (if applicable).
                                  required:
                                  - type
                                  - nullable
                                  title: DataType
                                comment:
                                  type: string
                                  description: A comment or description for the column.
                              title: sql.v1.ColumnCommon
                            - type: object
                              required:
                              - kind
                              properties:
                                name:
                                  example: user_id
                                type:
                                  example:
                                    type: BIGINT
                                    nullable: false
                                kind:
                                  type: string
                                  description: The kind of column.
                                  enum:
                                  - Physical
                                  example: Physical
                            title: sql.v1.PhysicalColumn
                          - description: Metadata columns reference system properties.
                            allOf:
                            - type: object
                              required:
                              - name
                              - type
                              properties:
                                name:
                                  type: string
                                  description: The name of the column.
                                type:
                                  type: object
                                  properties:
                                    type:
                                      type: string
                                      description: The data type of the column.
                                    nullable:
                                      type: boolean
                                      description: Indicates whether values in this column can be null.
                                    length:
                                      type: integer
                                      format: int32
                                      description: The length of the data type.
                                    precision:
                                      type: integer
                                      format: int32
                                      description: The precision of the data type.
                                    scale:
                                      type: integer
                                      format: int32
                                      description: The scale of the data type.
                                    key_type:
                                      allOf:
                                      - circular(DataType)
                                      description: The type of the key in the data type (if applicable).
                                    value_type:
                                      allOf:
                                      - circular(DataType)
                                      description: The type of the value in the data type (if applicable).
                                    element_type:
                                      allOf:
                                      - circular(DataType)
                                      description: The type of the element in the data type (if applicable).
                                    fields:
                                      type: array
                                      items:
                                        type: object
                                        properties:
                                          name:
                                            type: string
                                            description: The name of the field.
                                          field_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The data type of the field.
                                          description:
                                            type: string
                                            description: The description of the field.
                                        required:
                                        - name
                                        - field_type
                                        title: RowFieldType
                                      description: The fields of the element in the data type (if applicable).
                                    resolution:
                                      type: string
                                      description: The resolution of the data type (if applicable).
                                    fractional_precision:
                                      type: integer
                                      format: int32
                                      description: The fractional precision of the data type (if applicable).
                                    class_name:
                                      type: string
                                      description: The class name of the structured data type (if applicable).
                                  required:
                                  - type
                                  - nullable
                                  title: DataType
                                comment:
                                  type: string
                                  description: A comment or description for the column.
                              title: sql.v1.ColumnCommon
                            - type: object
                              required:
                              - kind
                              - metadata_key
                              properties:
                                name:
                                  example: table_offset
                                type:
                                  example:
                                    type: BIGINT
                                    nullable: false
                                kind:
                                  type: string
                                  description: The kind of column.
                                  enum:
                                  - Metadata
                                  example: Metadata
                                metadata_key:
                                  type: string
                                  description: The system metadata key to reference.
                                  example: offset
                                virtual:
                                  type: boolean
                                  description: Indicates if the metadata column is virtual.
                                  default: false
                                  example: true
                            title: sql.v1.MetadataColumn
                          - description: Computed columns are generated via an expression.
                            allOf:
                            - type: object
                              required:
                              - name
                              - type
                              properties:
                                name:
                                  type: string
                                  description: The name of the column.
                                type:
                                  type: object
                                  properties:
                                    type:
                                      type: string
                                      description: The data type of the column.
                                    nullable:
                                      type: boolean
                                      description: Indicates whether values in this column can be null.
                                    length:
                                      type: integer
                                      format: int32
                                      description: The length of the data type.
                                    precision:
                                      type: integer
                                      format: int32
                                      description: The precision of the data type.
                                    scale:
                                      type: integer
                                      format: int32
                                      description: The scale of the data type.
                                    key_type:
                                      allOf:
                                      - circular(DataType)
                                      description: The type of the key in the data type (if applicable).
                                    value_type:
                                      allOf:
                                      - circular(DataType)
                                      description: The type of the value in the data type (if applicable).
                                    element_type:
                                      allOf:
                                      - circular(DataType)
                                      description: The type of the element in the data type (if applicable).
                                    fields:
                                      type: array
                                      items:
                                        type: object
                                        properties:
                                          name:
                                            type: string
                                            description: The name of the field.
                                          field_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The data type of the field.
                                          description:
                                            type: string
                                            description: The description of the field.
                                        required:
                                        - name
                                        - field_type
                                        title: RowFieldType
                                      description: The fields of the element in the data type (if applicable).
                                    resolution:
                                      type: string
                                      description: The resolution of the data type (if applicable).
                                    fractional_precision:
                                      type: integer
                                      format: int32
                                      description: The fractional precision of the data type (if applicable).
                                    class_name:
                                      type: string
                                      description: The class name of the structured data type (if applicable).
                                  required:
                                  - type
                                  - nullable
                                  title: DataType
                                comment:
                                  type: string
                                  description: A comment or description for the column.
                              title: sql.v1.ColumnCommon
                            - type: object
                              required:
                              - kind
                              - expression
                              properties:
                                name:
                                  example: total_price
                                type:
                                  example:
                                    type: DECIMAL
                                    nullable: false
                                    precision: 10
                                    scale: 2
                                kind:
                                  type: string
                                  description: The kind of column.
                                  enum:
                                  - Computed
                                  example: Computed
                                expression:
                                  type: string
                                  description: The SQL expression used to compute the column value.
                                  example: quantity * price
                                virtual:
                                  type: boolean
                                  description: Indicates if the computed column is virtual.
                                  default: false
                                  example: true
                            title: sql.v1.ComputedColumn
                          title: sql.v1.ColumnDetails
                      watermark:
                        type: object
                        description: Watermark strategy for the Materialized Table resource.
                        properties:
                          column:
                            type: string
                            example: event_timestamp
                          expression:
                            type: string
                            example: event_timestamp - INTERVAL '5' SECOND
                        title: sql.v1.Watermark
                      constraints:
                        type: array
                        description: Specify table constraints.
                        items:
                          type: object
                          description: A constraint on the materialized table.
                          properties:
                            name:
                              type: string
                              example: pk_orders
                            type:
                              type: string
                              description: The type of constraint.
                              example: PRIMARY_KEY
                              enum:
                              - PRIMARY_KEY
                            columns:
                              type: array
                              items:
                                type: string
                              example:
                              - user_id
                              - product_id
                            enforced:
                              type: boolean
                              description: Whether the constraint is enforced.
                              default: false
                          title: sql.v1.Constraint
                      distribution:
                        description: Only applicable on creation; ignored on update.
                        allOf:
                        - type: object
                          description: Distribution (bucket by) strategy.
                          required:
                          - kind
                          properties:
                            kind:
                              type: string
                              description: The kind of distribution.
                              example: HASH
                              enum:
                              - HASH
                            keys:
                              type: array
                              items:
                                type: string
                              example:
                              - user_id
                            bucket_count:
                              type: integer
                              format: int32
                              minimum: 1
                              default: 6
                              description: The number of buckets.
                              example: 12
                          title: sql.v1.Distribution
                      query:
                        type: string
                        description: Contains the query section (usually starting with a SELECT) of the
                          latest Materialized Table.
                        example: SELECT user_id, product_id, price, quantity FROM orders WHERE price >
                          1000;
                        maxLength: 131072
                    title: sql.v1.MaterializedTableSpec
                title: sql.v1.MaterializedTable
              - type: object
                required:
                - spec
                properties:
                  spec:
                    type: object
                    required:
                    - query
                    - kafka_cluster_id
      responses:
        '201':
          description: Materialized Table is being created
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            Location:
              schema:
                type: string
                format: uri
                example: https://flink.region.provider.confluent.cloud/sql/v1/organizations/{organization_id}/environments/{environment_id}/databases/{kafka_cluster_id}/materialized-tables/{table_name}
              description: Materialized Table uri
          content:
            application/json:
              schema:
                allOf:
                - type: object
                  description: Represents a Materialized Table resource.
                  required:
                  - api_version
                  - kind
                  - metadata
                  - name
                  - organization_id
                  - environment_id
                  - spec
                  properties:
                    api_version:
                      type: string
                      enum:
                      - sql/v1
                      description: APIVersion defines the schema version of this representation of a resource.
                      example: sql/v1
                      readOnly: true
                    kind:
                      type: string
                      description: Kind defines the object this REST resource represents.
                      enum:
                      - MaterializedTable
                      readOnly: true
                    metadata:
                      allOf:
                      - description: ObjectMeta is metadata that all persisted resources must have, which
                          includes all objects users must create.
                        required:
                        - self
                        properties:
                          self:
                            description: Self is a Uniform Resource Locator (URL) at which an object can
                              be addressed. This URL encodes the service location, API version, and other
                              particulars necessary to locate the resource at a point in time
                            type: string
                            format: uri
                            readOnly: true
                            example: https://api.confluent.cloud/v2/kafka-clusters/lkc-f3a90de
                          resource_name:
                            description: Resource Name is a Uniform Resource Identifier (URI) that is
                              globally unique across space and time. It is represented as a Confluent
                              Resource Name
                            type: string
                            format: uri
                            readOnly: true
                            example: crn://confluent.cloud/kafka=lkc-f3a90de
                          created_at:
                            type: string
                            format: date-time
                            example: '2006-01-02T15:04:05-07:00'
                            readOnly: true
                            description: The date and time at which this object was created. It is represented
                              in RFC3339 format and is in UTC.
                          updated_at:
                            type: string
                            format: date-time
                            example: '2006-01-02T15:04:05-07:00'
                            readOnly: true
                            description: The date and time at which this object was last updated. It is
                              represented in RFC3339 format and is in UTC.
                          deleted_at:
                            type: string
                            format: date-time
                            example: '2006-01-02T15:04:05-07:00'
                            readOnly: true
                            description: The date and time at which this object was (or will be) deleted.
                              It is represented in RFC3339 format and is in UTC.
                        readOnly: true
                        title: ObjectMeta
                      - type: object
                        properties:
                          self:
                            example: https://flink.us-west1.aws.confluent.cloud/sql/v1/environments/env-123/databases/lkc-123/materialized-tables/high-value-orders
                          uid:
                            example: 12345678-1234-1234-1234-123456789012
                          resource_version:
                            example: a23av
                          resource_name:
                            example: ''
                          labels:
                            type: object
                            additionalProperties:
                              type: string
                    name:
                      type: string
                      description: The user-provided name of the resource, unique within the Kafka cluster.
                        May contain ASCII alphanumerics, '.', '_' and '-'; must not be '.' or '..'; max
                        length 249.
                      pattern: ^[a-zA-Z0-9._-]+$
                      maxLength: 249
                      example: high-value-orders
                      x-immutable: true
                    organization_id:
                      type: string
                      format: uuid
                      description: The unique identifier for the organization.
                      x-immutable: true
                      readOnly: true
                    environment_id:
                      type: string
                      description: The unique identifier for the environment.
                      x-immutable: true
                      readOnly: true
                    spec:
                      type: object
                      description: The specifications of the Materialized Table.
                      properties:
                        kafka_cluster_id:
                          type: string
                          description: 'The ID of the Kafka cluster hosting the Materialized Table''s
                            topic.

                            This value must match the `kafka_cluster_id` path parameter.

                            It is immutable after creation and is ignored or rejected on update if changed.'
                          example: lkc-12345
                          x-immutable: true
                        compute_pool_id:
                          type: string
                          description: 'The id associated with the compute pool in context.

                            If not specified, the materialized table will use the default compute pool.
                            The default pool is automatically determined by the system.'
                          example: lfcp-123
                        principal:
                          type: string
                          description: The id of a principal this Materialized Table query runs as.
                          example: sa-abc123
                          maxLength: 255
                        stopped:
                          type: boolean
                          description: Indicates whether the Materialized Table query should be stopped.
                          example: false
                        table_options:
                          type: object
                          description: Defines configuration properties for the table, equivalent to the
                            SQL 'WITH' clause
                          additionalProperties:
                            type: string
                          maxProperties: 8192
                        session_options:
                          type: object
                          description: Session configurations equivalent to the SQL 'SET' statement. Only
                            applicable on creation; ignored on update.
                          additionalProperties:
                            type: string
                          maxProperties: 8192
                          x-immutable: true
                        columns:
                          type: array
                          description: Details of each column in Materialized Table resource. If columns
                            are not specified, we infer from query. If it's specified it must be compatible
                            with the types in the query.
                          items:
                            type: object
                            description: Details of a column in the Materialized Table.
                            discriminator:
                              propertyName: kind
                              mapping:
                                Physical:
                                  description: Physical columns define the structure of the table and
                                    the data types of its fields.
                                  allOf:
                                  - type: object
                                    required:
                                    - name
                                    - type
                                    properties:
                                      name:
                                        type: string
                                        description: The name of the column.
                                      type:
                                        type: object
                                        properties:
                                          type:
                                            type: string
                                            description: The data type of the column.
                                          nullable:
                                            type: boolean
                                            description: Indicates whether values in this column can be
                                              null.
                                          length:
                                            type: integer
                                            format: int32
                                            description: The length of the data type.
                                          precision:
                                            type: integer
                                            format: int32
                                            description: The precision of the data type.
                                          scale:
                                            type: integer
                                            format: int32
                                            description: The scale of the data type.
                                          key_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the key in the data type (if applicable).
                                          value_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the value in the data type (if applicable).
                                          element_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the element in the data type (if
                                              applicable).
                                          fields:
                                            type: array
                                            items:
                                              type: object
                                              properties:
                                                name:
                                                  type: string
                                                  description: The name of the field.
                                                field_type:
                                                  allOf:
                                                  - circular(DataType)
                                                  description: The data type of the field.
                                                description:
                                                  type: string
                                                  description: The description of the field.
                                              required:
                                              - name
                                              - field_type
                                              title: RowFieldType
                                            description: The fields of the element in the data type (if
                                              applicable).
                                          resolution:
                                            type: string
                                            description: The resolution of the data type (if applicable).
                                          fractional_precision:
                                            type: integer
                                            format: int32
                                            description: The fractional precision of the data type (if
                                              applicable).
                                          class_name:
                                            type: string
                                            description: The class name of the structured data type (if
                                              applicable).
                                        required:
                                        - type
                                        - nullable
                                        title: DataType
                                      comment:
                                        type: string
                                        description: A comment or description for the column.
                                    title: sql.v1.ColumnCommon
                                  - type: object
                                    required:
                                    - kind
                                    properties:
                                      name:
                                        example: user_id
                                      type:
                                        example:
                                          type: BIGINT
                                          nullable: false
                                      kind:
                                        type: string
                                        description: The kind of column.
                                        enum:
                                        - Physical
                                        example: Physical
                                  title: sql.v1.PhysicalColumn
                                Metadata:
                                  description: Metadata columns reference system properties.
                                  allOf:
                                  - type: object
                                    required:
                                    - name
                                    - type
                                    properties:
                                      name:
                                        type: string
                                        description: The name of the column.
                                      type:
                                        type: object
                                        properties:
                                          type:
                                            type: string
                                            description: The data type of the column.
                                          nullable:
                                            type: boolean
                                            description: Indicates whether values in this column can be
                                              null.
                                          length:
                                            type: integer
                                            format: int32
                                            description: The length of the data type.
                                          precision:
                                            type: integer
                                            format: int32
                                            description: The precision of the data type.
                                          scale:
                                            type: integer
                                            format: int32
                                            description: The scale of the data type.
                                          key_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the key in the data type (if applicable).
                                          value_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the value in the data type (if applicable).
                                          element_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the element in the data type (if
                                              applicable).
                                          fields:
                                            type: array
                                            items:
                                              type: object
                                              properties:
                                                name:
                                                  type: string
                                                  description: The name of the field.
                                                field_type:
                                                  allOf:
                                                  - circular(DataType)
                                                  description: The data type of the field.
                                                description:
                                                  type: string
                                                  description: The description of the field.
                                              required:
                                              - name
                                              - field_type
                                              title: RowFieldType
                                            description: The fields of the element in the data type (if
                                              applicable).
                                          resolution:
                                            type: string
                                            description: The resolution of the data type (if applicable).
                                          fractional_precision:
                                            type: integer
                                            format: int32
                                            description: The fractional precision of the data type (if
                                              applicable).
                                          class_name:
                                            type: string
                                            description: The class name of the structured data type (if
                                              applicable).
                                        required:
                                        - type
                                        - nullable
                                        title: DataType
                                      comment:
                                        type: string
                                        description: A comment or description for the column.
                                    title: sql.v1.ColumnCommon
                                  - type: object
                                    required:
                                    - kind
                                    - metadata_key
                                    properties:
                                      name:
                                        example: table_offset
                                      type:
                                        example:
                                          type: BIGINT
                                          nullable: false
                                      kind:
                                        type: string
                                        description: The kind of column.
                                        enum:
                                        - Metadata
                                        example: Metadata
                                      metadata_key:
                                        type: string
                                        description: The system metadata key to reference.
                                        example: offset
                                      virtual:
                                        type: boolean
                                        description: Indicates if the metadata column is virtual.
                                        default: false
                                        example: true
                                  title: sql.v1.MetadataColumn
                                Computed:
                                  description: Computed columns are generated via an expression.
                                  allOf:
                                  - type: object
                                    required:
                                    - name
                                    - type
                                    properties:
                                      name:
                                        type: string
                                        description: The name of the column.
                                      type:
                                        type: object
                                        properties:
                                          type:
                                            type: string
                                            description: The data type of the column.
                                          nullable:
                                            type: boolean
                                            description: Indicates whether values in this column can be
                                              null.
                                          length:
                                            type: integer
                                            format: int32
                                            description: The length of the data type.
                                          precision:
                                            type: integer
                                            format: int32
                                            description: The precision of the data type.
                                          scale:
                                            type: integer
                                            format: int32
                                            description: The scale of the data type.
                                          key_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the key in the data type (if applicable).
                                          value_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the value in the data type (if applicable).
                                          element_type:
                                            allOf:
                                            - circular(DataType)
                                            description: The type of the element in the data type (if
                                              applicable).
                                          fields:
                                            type: array
                                            items:
                                              type: object
                                              properties:
                                                name:
                                                  type: string
                                                  description: The name of the field.
                                                field_type:
                                                  allOf:
                                                  - circular(DataType)
                                                  description: The data type of the field.
                                                description:
                                                  type: string
                                                  description: The description of the field.
                                              required:
                                              - name
                                              - field_type
                                              title: RowFieldType
                                            description: The fields of the element in the data type (if
                                              applicable).
                                          resolution:
                                            type: string
                                            description: The resolution of the data type (if applicable).
                                          fractional_precision:
                                            type: integer
                                            format: int32
                                            description: The fractional precision of the data type (if
                                              applicable).
                                          class_name:
                                            type: string
                                            description: The class name of the structured data type (if
                                              applicable).
                                        required:
                                        - type
                                        - nullable
                                        title: DataType
                                      comment:
                                        type: string
                                        description: A comment or description for the column.
                                    title: sql.v1.ColumnCommon
                                  - type: object
                                    required:
                                    - kind
                                    - expression
                                    properties:
                                      name:
                                        example: total_price
                                      type:
                                        example:
                                          type: DECIMAL
                                          nullable: false
                                          precision: 10
                                          scale: 2
                                      kind:
                                        type: string
                                        description: The kind of column.
                                        enum:
                                        - Computed
                                        example: Computed
                                      expression:
                                        type: string
                                        description: The SQL expression used to compute the column value.
                                        example: quantity * price
                                      virtual:
                                        type: boolean
                                        description: Indicates if the computed column is virtual.
                                        default: false
                                        example: true
                                  title: sql.v1.ComputedColumn
                            oneOf:
                            - description: Physical columns define the structure of the table and the
                                data types of its fields.
                              allOf:
                              - type: object
                                required:
                                - name
                                - type
                                properties:
                                  name:
                                    type: string
                                    description: The name of the column.
                                  type:
                                    type: object
                                    properties:
                                      type:
                                        type: string
                                        description: The data type of the column.
                                      nullable:
                                        type: boolean
                                        description: Indicates whether values in this column can be null.
                                      length:
                                        type: integer
                                        format: int32
                                        description: The length of the data type.
                                      precision:
                                        type: integer
                                        format: int32
                                        description: The precision of the data type.
                                      scale:
                                        type: integer
                                        format: int32
                                        description: The scale of the data type.
                                      key_type:
                                        allOf:
                                        - circular(DataType)
                                        description: The type of the key in the data type (if applicable).
                                      value_type:
                                        allOf:
                                        - circular(DataType)
                                        description: The type of the value in the data type (if applicable).
                                      element_type:
                                        allOf:
                                        - circular(DataType)
                                        description: The type of the element in the data type (if applicable).
                                      fields:
                                        type: array
                                        items:
                                          type: object
                                          properties:
                                            name:
                                              type: string
                                              description: The name of the field.
                                            field_type:
                                              allOf:
                                              - circular(DataType)
                                              description: The data type of the field.
                                            description:
                                              type: string
                                              description: The description of the field.
                                          required:
                                          - name
                                          - field_type
                                          title: RowFieldType
                                        description: The fields of the element in the data type (if applicable).
                                      resolution:
                                        type: string
                                        description: The resolution of the data type (if applicable).
                                      fractional_precision:
                                        type: integer
                                        format: int32
                                        description: The fractional precision of the data type (if applicable).
                                      class_name:
                                        type: string
                                        description: The class name of the structured data type (if applicable).
                                    required:
                                    - type
                                    - nullable
                                    title: DataType
                                  comment:
                                    type: string
                                    description: A comment or description for the column.
                                title: sql.v1.ColumnCommon
                              - type: object
                                required:
                                - kind
                                properties:
                                  name:
                                    example: user_id
                                  type:
                                    example:
                                      type: BIGINT
                                      nullable: false
                                  kind:
                                    type: string
                                    description: The kind of column.
                                    enum:
                                    - Physical
                                    example: Physical
                              title: sql.v1.PhysicalColumn
                            - description: Metadata columns reference system properties.
                              allOf:
                              - type: object
                                required:
                                - name
                                - type
                                properties:
                                  name:
                                    type: string
                                    description: The name of the column.
                                  type:
                                    type: object
                                    properties:
                                      type:
                                        type: string
                                        description: The data type of the column.
                                      nullable:
                                        type: boolean
                                        description: Indicates whether values in this column can be null.
                                      length:
                                        type: integer
                                        format: int32
                                        description: The length of the data type.
                                      precision:
                                        type: integer
                                        format: int32
                                        description: The precision of the data type.
                                      scale:
                                        type: integer
                                        format: int32
                                        description: The scale of the data type.
                                      key_type:
                                        allOf:
                                        - circular(DataType)
                                        description: The type of the key in the data type (if applicable).
                                      value_type:
                                        allOf:
                                        - circular(DataType)
                                        description: The type of the value in the data type (if applicable).
                                      element_type:
                                        allOf:
                                        - circular(DataType)
                                        description: The type of the element in the data type (if applicable).
                                      fields:
                                        type: array
                                        items:
                                          type: object
                                          properties:
                                            name:
                                              type: string
                                              description: The name of the field.
                                            field_type:
                                              allOf:
                                              - circular(DataType)
                                              description: The data type of the field.
                                            description:
                                              type: string
                                              description: The description of the field.
                                          required:
                                          - name
                                          - field_type
                                          title: RowFieldType
                                        description: The fields of the element in the data type (if applicable).
                                      resolution:
                                        type: string
                                        description: The resolution of the data type (if applicable).
                                      fractional_precision:
                                        type: integer
                                        format: int32
                                        description: The fractional precision of the data type (if applicable).
                                      class_name:
                                        type: string
                                        description: The class name of the structured data type (if applicable).
                                    required:
                                    - type
                                    - nullable
                                    title: DataType
                                  comment:
                                    type: string
                                    description: A comment or description for the column.
                                title: sql.v1.ColumnCommon
                              - type: object
                                required:
                                - kind
                                - metadata_key
                                properties:
                                  name:
                                    example: table_offset
                                  type:
                                    example:
                                      type: BIGINT
                                      nullable: false
                                  kind:
                                    type: string
                                    description: The kind of column.
                                    enum:
                                    - Metadata
                                    example: Metadata
                                  metadata_key:
                                    type: string
                                    description: The system metadata key to reference.
                                    example: offset
                                  virtual:
                                    type: boolean
                                    description: Indicates if the metadata column is virtual.
                                    default: false
                                    example: true
                              title: sql.v1.MetadataColumn
                            - description: Computed columns are generated via an expression.
                              allOf:
                              - type: object
                                required:
                                - name
                                - type
                                properties:
                                  name:
                                    type: string
                                    description: The name of the column.
                                  type:
                                    type: object
                                    properties:
                                      type:
                                        type: string
                                        description: The data type of the column.
                                      nullable:
                                        type: boolean
                                        description: Indicates whether values in this column can be null.
                                      length:
                                        type: integer
                                        format: int32
                                        description: The length of the data type.
                                      precision:
                                        type: integer
                                        format: int32
                                        description: The precision of the data type.
                                      scale:
                                        type: integer
                                        format: int32
                                        description: The scale of the data type.
                                      key_type:
                                        allOf:
                                        - circular(DataType)
                                        description: The type of the key in the data type (if applicable).
                                      value_type:
                                        allOf:
                                        - circular(DataType)
                                        description: The type of the value in the data type (if applicable).
                                      element_type:
                                        allOf:
                                        - circular(DataType)
                                        description: The type of the element in the data type (if applicable).
                                      fields:
                                        type: array
                                        items:
                                          type: object
                                          properties:
                                            name:
                                              type: string
                                              description: The name of the field.
                                            field_type:
                                              allOf:
                                              - circular(DataType)
                                              description: The data type of the field.
                                            description:
                                              type: string
                                              description: The description of the field.
                                          required:
                                          - name
                                          - field_type
                                          title: RowFieldType
                                        description: The fields of the element in the data type (if applicable).
                                      resolution:
                                        type: string
                                        description: The resolution of the data type (if applicable).
                                      fractional_precision:
                                        type: integer
                                        format: int32
                                        description: The fractional precision of the data type (if applicable).
                                      class_name:
                                        type: string
                                        description: The class name of the structured data type (if applicable).
                                    required:
                                    - type
                                    - nullable
                                    title: DataType
                                  comment:
                                    type: string
                                    description: A comment or description for the column.
                                title: sql.v1.ColumnCommon
                              - type: object
                                required:
                                - kind
                                - expression
                                properties:
                                  name:
                                    example: total_price
                                  type:
                                    example:
                                      type: DECIMAL
                                      nullable: false
                                      precision: 10
                                      scale: 2
                                  kind:
                                    type: string
                                    description: The kind of column.
                                    enum:
                                    - Computed
                                    example: Computed
                                  expression:
                                    type: string
                                    description: The SQL expression used to compute the column value.
                                    example: quantity * price
                                  virtual:
                                    type: boolean
                                    description: Indicates if the computed column is virtual.
                                    default: false
                                    example: true
                              title: sql.v1.ComputedColumn
                            title: sql.v1.ColumnDetails
                        watermark:
                          type: object
                          description: Watermark strategy for the Materialized Table resource.
                          properties:
                            column:
                              type: string
                              example: event_timestamp
                            expression:
                              type: string
                              example: event_timestamp - INTERVAL '5' SECOND
                          title: sql.v1.Watermark
                        constraints:
                          type: array
                          description: Specify table constraints.
                          items:
                            type: object
                            description: A constraint on the materialized table.
                            properties:
                              name:
                                type: string
                                example: pk_orders
                              type:
                                type: string
                                description: The type of constraint.
                                example: PRIMARY_KEY
                                enum:
                                - PRIMARY_KEY
                              columns:
                                type: array
                                items:
                                  type: string
                                example:
                                - user_id
                                - product_id
                              enforced:
                                type: boolean
                                description: Whether the constraint is enforced.
                                default: false
                            title: sql.v1.Constraint
                        distribution:
                          description: Only applicable on creation; ignored on update.
                          x-immutable: true
                          allOf:
                          - type: object
                            description: Distribution (bucket by) strategy.
                            required:
                            - kind
                            properties:
                              kind:
                                type: string
                                description: The kind of distribution.
                                example: HASH
                                enum:
                                - HASH
                              keys:
                                type: array
                                items:
                                  type: string
                                example:
                                - user_id
                              bucket_count:
                                type: integer
                                format: int32
                                minimum: 1
                                default: 6
                                description: The number of buckets.
                                example: 12
                            title: sql.v1.Distribution
                        query:
                          type: string
                          description: Contains the query section (usually starting with a SELECT) of
                            the latest Materialized Table.
                          example: SELECT user_id, product_id, price, quantity FROM orders WHERE price
                            > 1000;
                          maxLength: 131072
                      title: sql.v1.MaterializedTableSpec
                    status:
                      readOnly: true
                      allOf:
                      - type: object
                        description: The status of the Materialized Table.
                        properties:
                          phase:
                            type: string
                            description: The lifecycle phase of the materialized table.
                            example: RUNNING
[...]
